'use strict';

// src/index.ts
var googleMapsLoader = (() => {
  let options;
  let scriptOptions;
  let callbackName;
  const GoogleMapsLoader = (_options, _scriptProps, _callbackName) => {
    options = _options;
    scriptOptions = _scriptProps || {};
    callbackName = _callbackName || "__gmlcb";
    return GoogleMapsLoader;
  };
  const completion = new Promise((resolve, reject) => {
    let status = 0 /* NONE */;
    let error;
    const statuses = ["none", "loading", "loaded", "error"];
    const store = /* @__PURE__ */ new Map();
    const handleOnline = (cb, ifOnline) => {
      if (navigator.onLine) {
        (ifOnline || cb)();
      } else {
        window.addEventListener("online", cb, { once: true });
      }
    };
    const initData = (key) => {
      let load;
      const data = [
        0 /* NONE */,
        new Promise((res, rej) => {
          load = () => {
            const reject2 = (err) => {
              handleOnline(load, () => {
                data[0] = 3 /* ERROR */;
                data[3] = err;
                rej(err);
              });
            };
            completion.then(() => {
              google.maps.importLibrary(key).then((value) => {
                data[0] = 2 /* LOADED */;
                data[2] = value;
                res(value);
              }, reject2);
            }, reject2);
          };
        }),
        void 0,
        void 0,
        load
      ];
      store.set(key, data);
      return data;
    };
    const createCompletionGetter = (getCompletion, onetime) => (...libraries) => {
      if (onetime) {
        onetime = onetime();
      }
      const l = libraries.length;
      return l ? l > 1 ? Promise.all(libraries.map(getCompletion)) : getCompletion(libraries[0]) : completion;
    };
    GoogleMapsLoader.get = (key) => store.has(key) ? store.get(key)[2] : void 0;
    GoogleMapsLoader.getError = (key) => key ? store.has(key) ? store.get(key)[3] : void 0 : error;
    GoogleMapsLoader.getStatus = (key) => statuses[key ? store.has(key) ? store.get(key)[0] : 0 /* NONE */ : status];
    GoogleMapsLoader.getCompletion = createCompletionGetter((key) => (store.get(key) || initData(key))[1]);
    GoogleMapsLoader.load = createCompletionGetter(
      (key) => {
        const data = store.get(key) || initData(key);
        if (!data[0]) {
          data[0] = 1 /* LOADING */;
          handleOnline(data.pop());
        }
        return data[1];
      },
      () => {
        let errorMessage;
        if (!options) {
          errorMessage = "no options was set";
        } else if (window.google && google.maps) {
          errorMessage = "google.maps already loaded";
        }
        if (errorMessage) {
          status = 3 /* ERROR */;
          reject(error = new Error(errorMessage));
        } else {
          status = 1 /* LOADING */;
          const src = Object.keys(options).reduce(
            (acc, key) => `${acc}&${key}=${options[key]}`,
            `https://maps.googleapis.com/maps/api/js?callback=${callbackName}&loading=async`
          );
          const createScript = () => {
            const script = document.createElement("script");
            script.type = "text/javascript";
            script.onerror = () => {
              script.remove();
              handleOnline(createScript, () => {
                status = 3 /* ERROR */;
                reject(error = new Error("google.maps could not load"));
              });
            };
            script.src = src;
            for (const key in scriptOptions) {
              script[key] = scriptOptions[key];
            }
            document.head.appendChild(script);
          };
          window[callbackName] = () => {
            delete window[callbackName];
            status = 2 /* LOADED */;
            resolve();
          };
          handleOnline(createScript);
        }
      }
    );
  });
  return GoogleMapsLoader;
})();

exports.GoogleMapsLoader = googleMapsLoader;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=index.cjs.map